[🇺🇸 Read this in english](en_US/README.md)

![shellpunks](visual/banner_shellpunks.png)

[![Wiki](https://img.shields.io/badge/wiki-lightgrey.svg?longCache=true&style=for-the-badge)](https://git.disroot.org/Paradigma/Shellpunks/wiki) [![Código de Conduta](https://img.shields.io/badge/c%C3%B3digo%20de%20conduta-red.svg?longCache=true&style=for-the-badge)](https://git.disroot.org/Paradigma/Paradigma/wiki/pt_BR%2FC%C3%B3digo-de-Conduta)

## Sumário

1. [Introdução](#introdução)

2. [Emuladores de terminal](#emuladores-de-terminal)

3. [Shells](#shells)

4. [Editores de texto](#editores-de-texto)

5. [Multiplexadores](#multiplexadores)

6. Ferramentas e Plugins

    1. [Consulta e aprendizado](#consulta-e-aprendizado)

    2. [Arquivos e Diretórios](#arquivos-e-diretorios)

    3. [Envio e recebimento](#envio-e-recebimento)

    4. [Manipulação de dados](#manipulação-de-dados)

    5. [Multimedia](#multimedia)

    6. [Git](#git)

    7. [Personalização](#personalização)

7. [Guias](#guias)

8. [Referências](#referências)

## Introdução

Toda semana, nos encontramos para discutir e demonstrar novas e interessantes maneiras de fazer uso do terminal, também conhecido como a *Interface de Linha de Comando*, nesta atividade a qual nomeamos carinhosamente de **Shellpunks**.

Fundamos essa atividade na crença de que na cooperação e na autonomia, encontramos os motores do nosso desenvolvimento. Tanto como indivíduos, quanto como comunidade. A ideia de dispor da informação tal como um privilégio, por qualquer razão, de nós não encontra nada senão o mais absoluto desprezo. Por isso, sempre que possível, fazemos disponível aqui tudo aquilo que apresentamos. Para que todos sejam capazes de usufruir de nossas contribuições e colaborar para alcançarmos objetivos mais grandiosos como um todo.

Através do resultado apresentado no Shellpunks, produzimos e realizamos a curadoria aqui de uma lista de recursos e ferramentas de interesse aos seus participantes. Para saber mais sobre este evento, como participar e contribuir nele, consulte a página à respeito desta em nosso [Wiki](https://git.disroot.org/Paradigma/Paradigma/wiki/Home) ou venha bater um papo conosco no [Telegram](t.me/paradigma_icu).

## Emuladores de terminal

| Nome | Descrição | Disponível para |
| :------------- | :------------- | :------------ |
[gnome-terminal](https://wiki.gnome.org/Apps/Terminal) | Um emulador terminal com recurso de abas e perfis de usuário | Linux/BSD
[hyper](https://hyper.is/) | Um terminal construído sobre tecnologias web. | Linux/BSD, MacOS, Windows
[st](https://st.suckless.org/) | Um terminal simples. | Linux/BSD
[terminator](https://gnometerminator.blogspot.com/p/introduction.html) | O futuro robótico dos terminais | Linux/BSD
[termux](https://termux.com/) | Um applicativo de emulação de terminal com ambiente Linux que funciona sem a necessidade de privilégios de administrador ou qualquer configuração. | Android
[tilix](https://gnunn1.github.io/tilix-web/) | Um emulador de terminal rico em recursos que se adequa às orientações de design para interfaces do GNOME | Linux/BSD
[upterm](https://github.com/railsware/upterm) | Um emulador de terminal para ao século 21. | Linux/BSD, MacOs
[xfce4-terminal](https://docs.xfce.org/apps/terminal/start) | Um emulador de terminal leve e fácil de usar | Linux/BSD

## Shells

| Nome | Descrição  |
| :------------- | :------------- |
[bash](https://www.gnu.org/software/bash/) | **Bourne Again SHell**, o shell do projeto GNU. O shell padrão do macOS, Android e diversas distribuições Linux.
[fish](https://fishshell.com/) | **Friendly Interactive SHell**. Finalmente um shell de linha de comando para os anos 90s.
[powershell](https://github.com/PowerShell/PowerShell) | O Shell padrão do Windows.
[zsh](http://www.zsh.org/) | Um shell projetado para uso interativo, ebora também seja uma poderosa linguagem para scripts.

## Editores de texto

| Nome | Descrição |
| :------------- | :------------- |
[micro](https://github.com/zyedidia/micro) | Um editor de texto de terminal moderno e intuitivo.
[nano](https://www.nano-editor.org/) | Pequeno e amigável editor de texto inspirado no Pico.
[spacemacs](http://spacemacs.org/) | Distribuição do [emacs](https://www.gnu.org/software/emacs/) mantida pela comunidade.
[vim](https://www.vim.org/) | Um editor de texto altamente configurável para criar e modificar qualquer tipo de texto de maneira eficiente.

## Multiplexadores

> Um multiplexador de terminais, em suma, é uma ferramenta que permite utilizar varios terminais usando uma mesma janela. Assim como, também, manter processos rodando após sua janela correspondente ter sido fechada.

| Nome | Descrição |
| :------------- | :------------- |
[screen]( https://savannah.gnu.org/projects/screen) | ![20/10/2018 - apresentado no shellpunks](https://img.shields.io/badge/20%2F10%2F2018-apresentado%20no%20shellpunks-red.svg?longCache=true&style=popout-square)<br/> O multiplexador original do projeto GNU
[tmux]( https://tmux.github.io/) | ![20/10/2018 - apresentado no shellpunks](https://img.shields.io/badge/20%2F10%2F2018-apresentado%20no%20shellpunks-red.svg?longCache=true&style=popout-square)<br/> Um multiplexador moderno e altamente configurável

## Ferramentas e Plugins

### Consulta e aprendizado

| Nome | Descrição |
| :------------- | :------------- |
[cmdchallenge](https://cmdchallenge.com/) | Desafios a serem realizados usando bash.
[explainshell](http://www.explainshell.com/) | Digite uma linha de comando e tenha uma explicação para cada argumento apresentado.
[thefuck](https://github.com/nvbn/thefuck) | The Fuck busca corrigir falhas cometidas pelo usuário automáticamente, propondo comandos que se assemelham ao padrão apresentado.
[tldr](https://github.com/tldr-pages/tldr) | Manuais simplificados mantidos pela comunidade
[translate-shell](https://github.com/soimort/translate-shell) | Uma interface simples de linha de comando que o permite traduzir quaisquer palavras ou frases usando resultados retirados do Google Translate

### Arquivos e Diretórios

| Nome | Descrição |
| :------------- | :------------- |
[ad](https://github.com/tanrax/terminal-AdvancedNewFile) | Fast creation of files and directories in a recursive way. Inspired by the Vim plugin.
[nav](https://git.disroot.org/Lusiadas/nav) | ![autoral](https://img.shields.io/badge/autoral-blue.svg?longCache=true&style=popout-square) ![29/09/2018 - apresentado no shellpunks](https://img.shields.io/badge/29%2F08%2F2018-apresentado%20no%20shellpunks-red.svg?longCache=true&style=popout-square)<br/> **Navigational Assistance with Velocity -** Encontre e navegue entre diretórios rapidamente, realizando buscas por palavras-chave.
[rename-cli](https://github.com/jhotmann/node-rename-cli) | Renomeie arquivos rapidamente, especialmente múltiplos arquivos simultaneamente.

### Envio e recebimento

| Nome | Descrição |
| :------------- | :------------- |
[elinks](http://elinks.cz/) | Um programa rico em recursos para navegar a web usando a interface de texto.
[publish](https://git.disroot.org/Lusiadas/publish) | ![autoral](https://img.shields.io/badge/autoral-blue.svg?longCache=true&style=popout-square) ![05/09/2018 - apresentado no shellpunks](https://img.shields.io/badge/05%2F09%2F2018-apresentado%20no%20shellpunks-red.svg?longCache=true&style=popout-square)<br/> Com um único comando, publique um ou mais arquivos de texto (ou apenas trechos destes) em um pastebin e obtenha URLs para compatilha-los.
[wifish](https://github.com/bougyman/wifish) | Liste pontos de acesso Wifi e conecte-se a um deles pelo terminal.

### Manipulação de dados

| Nome | Descrição |
| :------------- | :------------- |
[ag](https://github.com/ggreer/the_silver_searcher) | Busca rápida e recursiva por termos no conteúdo de um diretório de arquivos.
[pass](https://www.passwordstore.org/) | ![27/10/2018 - apresentado no shellpunks](https://img.shields.io/badge/27%2F10%2F2018-apresentado%20no%20shellpunks-red.svg?longCache=true&style=popout-square)<br/> Um gerenciador de banco de senhas adequado às convenções Unix.
[fuzzy](https://git.disroot.org/Lusiadas/fuzzy) | ![autoral](https://img.shields.io/badge/autoral-blue.svg?longCache=true&style=popout-square) ![19/09/2018 - apresentado no shellpunks](https://img.shields.io/badge/19%2F09%2F2018-apresentado%20no%20shellpunks-red.svg?longCache=true&style=popout-square)<br/> Procure por comandos, arquivos ou processos sendo executados buscando por termos.

### Multimedia

| Nome | Descrição |
| :------------- | :------------- |
[asciinema](https://asciinema.org) | Desfrute de uma solução leve, puramente baseada em texto, para a gravação do terminal.
[mpsyt](https://github.com/np1/mps-youtube) | Navegue, ouça músicas e baixe vídeos do Youtube usando o terminal.

### Git

| Nome | Descrição |
| :------------- | :------------- |
[omf](https://github.com/oh-my-fish/oh-my-fish/blob/master/docs/pt-BR/README.md) | Uma ferramenta para instalar plugins que estendam as capacidades, ou a aparência, do seu fish shell. Ela é rápida, extensível e fácil de usar.
[tig](https://jonas.github.io/tig/) | Interface de texto baseada em ncurses para navegar em repositórios git.
[tpm](https://github.com/tmux-plugins/tpm) | ![20/10/2018 - apresentado no shellpunks](https://img.shields.io/badge/20%2F10%2F2018-apresentado%20no%20shellpunks-red.svg?longCache=true&style=popout-square)<br/> Gerenciador de plugins para [tmux](https://tmux.github.io/)

### Personalização

| Nome | Descrição |
| :------------- | :------------- |
[otacon](https://git.disroot.org/Lusiadas/otacon) | ![autoral](https://img.shields.io/badge/autoral-blue.svg?longCache=true&style=popout-square) ![20/10/2018 - apresentado no shellpunks](https://img.shields.io/badge/20%2F10%2F2018-apresentado%20no%20shellpunks-red.svg?longCache=true&style=popout-square)<br/> Uma versão simplificada do tema [fox](https://github.com/Posnet/fish-theme) otimizada para telas verticais e com uma barra de status complementar para o [tmux](https://tmux.github.io/).
[min](https://git.disroot.org/Lusiadas/min) | ![autoral](https://img.shields.io/badge/autoral-blue.svg?longCache=true&style=popout-square) ![20/10/2018 - apresentado no shellpunks](https://img.shields.io/badge/20%2F10%2F2018-apresentado%20no%20shellpunks-red.svg?longCache=true&style=popout-square)<br/> Um prompt mínimo com uma barra de status complementar para o [tmux](https://tmux.github.io/).

## Guias

[Bash Hackers Wiki](http://wiki.bash-hackers.org/)

[Greg's Wooledge Wiki](http://mywiki.wooledge.org/)

[The Linux Documentation Project: Bash Programming - Intro/How-to](http://tldp.org/HOWTO/Bash-Prog-Intro-HOWTO.html#toc)

[The Linux Documentation Project: Advanced Bash Scripting Guide](http://www.tldp.org/LDP/abs/html/)

[WikiBooks: Bash Shell Scripting](https://en.wikibooks.org/wiki/Bash_Shell_Scripting)

[Use the Unofficial Bash Strict Mode (Unless You Looove Debugging)](http://redsymbol.net/articles/unofficial-bash-strict-mode/)

[A arte da Linha de Comando](https://github.com/jlevy/the-art-of-command-line/blob/master/README-pt.md)

[Learn Enough Command Line To Be Dangerous](https://www.learnenough.com/command-line-tutorial)

[A guide to learn bash](https://github.com/Idnan/bash-guide)

## Referências

Além dos links apontados acima, esta página possui informações retiradas dos repositórios [awesome-cli-apps](https://github.com/agarrharr/awesome-cli-apps), [awesome-shell](https://github.com/alebcay/awesome-shell), e [terminals-are-sexy](https://github.com/k4m4/terminals-are-sexy). À eles somos gratos pela sua contribuição.
