[🇧🇷 Leia em português](/Paradigma/Shellpunks)

![shellpunks](visual/shellpunks_banner.png)

[![Wiki](https://img.shields.io/badge/wiki-lightgrey.svg?longCache=true&style=for-the-badge)](https://git.disroot.org/Paradigma/Shellpunks/wiki/en_US%2FHome) [![Code of Conduct](https://img.shields.io/badge/code%20of%20conduct-red.svg?longCache=true&style=for-the-badge)](https://git.disroot.org/Paradigma/Paradigma/wiki/en_US%2FCode-of-Conduct)

## Summary

1. [Introduction](#introduction)

2. [Terminal emulators](#terminal-emulators)

3. [Shells](#shells)

4. [Text editors](#text-editors)

5. [Multiplexers](#multiplexers)

6. Tools and Plugins

    1. [Reference and learning](#reference-and-learning)

    2. [Files and directories](#files-and-directories)

    3. [Download and serving](#download-and-serving)

    4. [Data manipulation](#data-manipulation)

    5. [Multimedia](#multimedia)

    6. [Git](#git)

    7. [Theming](#theming)

7. [Guides](#guides)

8. [References](#references)

## Introduction

Every week, we meet to discuss and show new and interesting ways to make use of the terminal, also know as the *Command Line Interface*, in this activity which we've dearly named **Shellpunks**.

We've founded this activity with the belief that in cooperation and autonomy, we find the motors of our development. Both as individuals, as a community. The idea of disposing of information as a privilege, for any reason, will find of us nothing but the most absolute contempt. Whenever possible, we make available everything that we demonstrate. That way, everyone should be capable to make use of our contributions and contribute to reach grander objectives as a whole.

Through the results presented at Shellpunks, we build and maintain here a list of resources of interest to its participants. **To know more about this event, how to participate and contribute to it, consult our [Wiki](https://gitlab.com/paradigma_/shellpunks/wiki) page on it or come chat with us on [Telegram](t.me/paradigma_icu)**

## Terminal Emulator

| Name | Description | Available for |
| :------------- | :------------- | :------------ |
[gnome-terminal](https://wiki.gnome.org/Apps/Terminal) | GNOME Terminal features the ability to use multiple terminals in a single  window (tabs) and profiles support. | Linux/BSD
[hyper](https://hyper.is/) | A terminal built on web technologies. | Linux/BSD, MacOS, Windows
[st](https://st.suckless.org/) | a simple terminal. | Linux/BSD
[terminator](https://gnometerminator.blogspot.com/p/introduction.html) | The robotic future of terminals | Linux/BSD
[termux](https://termux.com/) | an terminal emulator and Linux environment app that works directly with no rooting or setup required. | Android
[tilix](https://gnunn1.github.io/tilix-web/) | Tilix is a feature-rich tiling terminal emulator following the GNOME human interface design guidelines. | Linux/BSD
[upterm](https://github.com/railsware/upterm) | A terminal emulator for the 21<sup>st</sup> century. | Linux/BSD, MacOs
[xfce4-terminal](http://goodies.xfce.org/projects/applications/terminal) | a lightweight and easy to use terminal emulator | Linux/BSD

## Shells

| Name | Description |
| :------------- | :------------- |
[bash](https://www.gnu.org/software/bash/) | The **Bourne Again SHell**, Project GNU's own shell. This is the default shell for macOS, Android and a variety of Linux distributions.
[fish](https://fishshell.com/) | The **Friendly Interactive SHell**. Finally, a command line shell for the 90s.
[powershell](https://github.com/PowerShell/PowerShell) | Window's default shell.
[zsh](http://www.zsh.org/) | A shell designed for interactive use, although also a powerful scripting language.

## Text editors

| Nome | Descrição |
| :------------- | :------------- |
[micro](https://github.com/zyedidia/micro) | A modern and intuitive text editor for the terminal.
[nano](https://www.nano-editor.org/) | A small, friendly text editor inspired by Pico.
[spacemacs](http://spacemacs.org/) | A community driven distribution of [emacs](https://www.gnu.org/software/emacs/).

## Multiplexers

> A terminal multiplexer is, in short, a tool that allows one to use several terminals using a same window. Also, it can maintain processes running even after its window is closed,

| Nome | Descrição |
| :------------- | :------------- |
[screen]( https://savannah.gnu.org/projects/screen) | ![20/10/2018 - presented at shellpunks](https://img.shields.io/badge/20%2F10%2F2018-presented%20at%20shellpunks-red.svg?longCache=true&style=popout-square)<br/> the prototypical multiplexer from the GNU project
[tmux]( https://tmux.github.io/) | ![20/10/2018 - presented at shellpunks](https://img.shields.io/badge/20%2F10%2F2018-presented%20at%20shellpunks-red.svg?longCache=true&style=popout-square)<br/> A modern and highly configurable multiplexer

## Tools and plugins

### Reference and learning

| Name | Description |
| :------------- | :------------- |
[cmdchallenge](https://cmdchallenge.com/) | Solve tasks in a single line of bash.
[explainshell](http://www.explainshell.com/) | write down a command-line to see the help text that matches each argument.
[regexr](https://regexr.com/) | RegExr is an online tool to learn, build, & test Regular Expressions (RegEx / RegExp).
[thefuck](https://github.com/nvbn/thefuck) | The Fuck attempts to fix user's command line mistakes, by composing new commands applying a series of matching rules.
[tldr](https://github.com/tldr-pages/tldr) | Simplified community driven man pages
[translate-shell](https://github.com/soimort/translate-shell) | a simple command line interface to http://translate.google.com which allows you to translate strings in your terminal.

### Files and Directories

| Nome | Descrição |
| :------------- | :------------- |
[ad](https://github.com/tanrax/terminal-AdvancedNewFile) | Fast creation of files and directories in a recursive way. Inspired by the Vim plugin.
[nav](https://git.disroot.org/Lusiadas/nav) | ![authorial](https://img.shields.io/badge/authorial-blue.svg?longCache=true&style=popout-square) ![29/09/2018 - presented at shellpunks](https://img.shields.io/badge/29%2F08%2F2018-presented%20at%20shellpunks-red.svg?longCache=true&style=popout-square)<br/> **Navigational Assistance with Velocity -** In brief, it finds a folder whose name matches search patterns and makes it the current working directory.
[rename-cli](https://github.com/jhotmann/node-rename-cli) | A tool for renaming files quickly, especially multiple files at once.

### Downloading and serving

| Name | Description |
| :------------- | :------------- |
[elinks](http://elinks.cz/) | A feature-rich program for browsing the web in text mode.
[publish](https://git.disroot.org/Lusiadas/publish) | ![authorial](https://img.shields.io/badge/authorial-blue.svg?longCache=true&style=popout-square) ![05/09/2018 - presented at shellpunks](https://img.shields.io/badge/05%2F09%2F2018-presented%20at%20shellpunks-red.svg?longCache=true&style=popout-square)<br/> With a single command, publish the contents of the clipboard, or a file, or several, in its entirety or partially.
[wifish](https://github.com/bougyman/wifish) | List Wi-Fi access points and connect to one of them through the terminal.

### Data manipulation

| Name | Description |
| :------------- | :------------- |
[ag](https://github.com/ggreer/the_silver_searcher) | A code-searching tool similar to ack, but faster.
[pass](https://www.passwordstore.org/) | ![19/09/2018 - presented at shellpunks](https://img.shields.io/badge/27%2F10%2F2018-apresentado%20no%20shellpunks-red.svg?longCache=true&style=popout-square)<br/> the standard unix password manager.
[fuzzy](https://git.disroot.org/Lusiadas/fuzzy) | ![authorial](https://img.shields.io/badge/authorial-blue.svg?longCache=true&style=popout-square) ![27/10/2018 - presented at shellpunks](https://img.shields.io/badge/05%2F09%2F2018-presented%20at%20shellpunks-red.svg?longCache=true&style=popout-square)<br/> Fuzzy select commands, files, or running processes.

### Multimedia

| Name | Description |
| :------------- | :------------- |
[asciinema](https://asciinema.org) | Enjoy a lightweight, purely text based approach to terminal recording.
[mpsyt](https://github.com/np1/mps-youtube) | A terminal based YouTube client with an interactive text interface and in-built help.

### Git

| Name | Description |
| :------------- | :------------- |
[omf](https://github.com/oh-my-fish/oh-my-fish) | Install packages which extend or modify the look of your shell. It's fast, extensible and easy to use.
[tig](https://jonas.github.io/tig/) | An ncurses-based text-mode interface for git. It functions mainly as a Git repository browser.
[tpm](https://github.com/tmux-plugins/tpm) | ![20/10/2018 - presented at shellpunks](https://img.shields.io/badge/20%2F10%2F2018-presented%20at%20shellpunks-red.svg?longCache=true&style=popout-square)<br/> A plugin manager for [tmux](https://tmux.github.io/)

### Theming

| Nome | Descrição |
| :------------- | :------------- |
[otacon](https://git.disroot.org/Lusiadas/otacon) | ![authorial](https://img.shields.io/badge/authorial-blue.svg?longCache=true&style=popout-square) ![20/10/2018 - presented at shellpunks](https://img.shields.io/badge/20%2F10%2F2018-presented%20at%20shellpunks-red.svg?longCache=true&style=popout-square)<br/> A simplified version of the [fox](https://github.com/Posnet/fish-theme) theme, optimized to display information adjusted to the terminal length, with an accompaning status bar theme for [tmux](https://tmux.github.io).
[min](https://git.disroot.org/Lusiadas/min) | ![authorial](https://img.shields.io/badge/authorial-blue.svg?longCache=true&style=popout-square) ![20/10/2018 - presented at shellpunks](https://img.shields.io/badge/20%2F10%2F2018-presented%20at%20shellpunks-red.svg?longCache=true&style=popout-square)<br/> A minimal prompt with an accompaning status bar theme for [tmux](https://tmux.github.io).

## Guides

[The art of the command line](https://github.com/jlevy/the-art-of-command-line/blob/master/README.md)

[Unix CLI Crash and Burn Course](https://gitlab.com/shmibs/tutorials/blob/master/unix_cli_crash-and-burn_course/unix_cli_crash-and-burn_course.md)

[Bash Hackers Wiki](http://wiki.bash-hackers.org/)

[Greg's Wooledge Wiki](http://mywiki.wooledge.org/)

[The Linux Documentation Project: Bash Programming - Intro/How-to](http://tldp.org/HOWTO/Bash-Prog-Intro-HOWTO.html#toc)

[The Linux Documentation Project: Advanced Bash Scripting Guide](http://www.tldp.org/LDP/abs/html/)

[WikiBooks: Bash Shell Scripting](https://en.wikibooks.org/wiki/Bash_Shell_Scripting)

[Use the Unofficial Bash Strict Mode (Unless You Looove Debugging)](http://redsymbol.net/articles/unofficial-bash-strict-mode/)

[Learn Enough Command Line To Be Dangerous](https://www.learnenough.com/command-line-tutorial)

[A guide to learn bash](https://github.com/Idnan/bash-guide)

## References

Aside from the links presented above, this page has content drawn from the [awesome-cli-apps](https://github.com/agarrharr/awesome-cli-apps), [awesome-shell](https://github.com/alebcay/awesome-shell), and [terminals-are-sexy](https://github.com/k4m4/terminals-are-sexy) repositories. We're grateful for their contribution.

**[⬆ back to top](#summary)**